﻿using _123.Data.RemoteData.RemoteDatabase.DAO;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace _123.Data.RemoteData.RemoteDatabase
{
    public class RemoteDatabaseContext: DbContext
    {
        protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
        {
            optionsBuilder.UseNpgsql();
        }
        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.Entity<GroupDao>().HasKey(group => group.ID);
            modelBuilder.Entity<GroupDao>().Property(group => group.ID).ValueGeneratedOnAdd();
            modelBuilder.Entity<UserDao>().HasKey(user => user.UserGuid);
            modelBuilder.Entity<UserDao>().Property(user => user.UserGuid).ValueGeneratedOnAdd();
            modelBuilder.Entity<PresenceDao>().HasKey(presence => new
            {
                presence.UserGuid,
                presence.Date,
                presence.IsAttedance,
                presence.LessonNumber
            });
        }
        public DbSet<GroupDao> Groups { get; set; }
        public DbSet<UserDao> Users { get; set; }
        public DbSet<PresenceDao> PresencesDaos { get; set; }
    }
    }

