﻿using _123.Data.LocalData;
using _123.Data.LocalData.Entity;
using _123.Domain.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Xml.Linq;

namespace _123.Data.Repository
{
    public class PresenceRepositoryImpl : IPresenceRepository

    {
        public PresenceRepositoryImpl()
        {
            GetAllPresences = LocalStaticData.presences;
        }
        public List<PresenceLocalEntity> GetAllPresences
        { get; set; }

        public void AddPresence(PresenceLocalEntity presence)
        {
            PresenceLocalEntity? presenceLocal = GetAllPresences.FirstOrDefault();
            presenceLocal.UserGuid = presence.UserGuid;
            presenceLocal.Date = presence.Date;
            presenceLocal.IsAttedance = presence.IsAttedance;
            presenceLocal.LessonNumber = presence.LessonNumber;

        }

        public List<PresenceLocalEntity> GetPresenceByGroup(int groupId)
        {
            return GetAllPresences;
        }

        public List<PresenceLocalEntity> GetPresenceByGroupAndDate(int groupId, DateOnly date)
        {
            return GetAllPresences;
        }

        public bool UnCheckAttendence(int firstClass, int lastClass, DateOnly date, Guid userGuid)
        {
            var presToUpdate = GetAllPresences
                .Where(x => x.UserGuid == userGuid && x.LessonNumber >= firstClass
                && x.LessonNumber <= lastClass && x.Date == date).ToList();
            foreach (var presence in presToUpdate)
            {
                presence.IsAttedance = false;
            }
            return true;
        }

    }
}
